/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 8 janv. 2007 16:43:45

import java.math.BigDecimal;
import java.util.Enumeration;

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.carambole.server.NavigationCtrl;
import org.cocktail.fwkcktldepense.server.exception.FactoryException;
import org.cocktail.fwkcktldepense.server.finder.FinderArticle;
import org.cocktail.fwkcktldepense.server.finder.FinderAttribution;
import org.cocktail.fwkcktldepense.server.finder.FinderFournisseur;
import org.cocktail.fwkcktldepense.server.finder.FinderTypeAchat;
import org.cocktail.fwkcktldepense.server.metier.EOArticle;
import org.cocktail.fwkcktldepense.server.metier.EOAttribution;
import org.cocktail.fwkcktldepense.server.metier.EOCatalogue;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOFournisseur;
import org.cocktail.fwkcktldepense.server.metier.EOTypeAchat;
import org.cocktail.fwkcktldepense.server.util.ZStringUtil;

import com.webobjects.appserver.WOActionResults;
import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WOResponse;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.eocontrol.EOKeyValueQualifier;
import com.webobjects.eocontrol.EOQualifier;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSKeyValueCoding;
import com.webobjects.foundation.NSMutableArray;

public class ArticleListeSelection extends MyAjaxPage {

	private static final long serialVersionUID = 1L;
	//public WODisplayGroup dgArt = null;
	private NSArray<NSDictionary<String, Object>> lesArticlesSelectionnes = null;
	private NSArray<NSDictionary<String, Object>> lesArticlesAAfficher = null;
	private boolean modificationEnCours = false;
	private String avertissement = "";
	private boolean isCmdeMarche = false;
	private boolean isTypeAchatHorsMarche = false;
	private boolean isTypeAchatMonopole = false;
	private boolean isTypeAchat3cmp = false;
	private boolean isTypeAchatSansAchat = false;
	private NSArray<EOAttribution> attributionsCommunes = null;
	private EOAttribution uneAttributionCommune = null, uneAttributionCommuneSelectionnee = null;
	private String filterTextAttribution = "";
	private NSArray<EOTypeAchat> typesAchatCommuns = null;
	private EOTypeAchat unTypeAchatCommun = null, unTypeAchatCommunSelectionne = null;
	public NSArray<EOFournisseur> ssTraitants = null;
	public EOFournisseur unSsTraitant = null;
	private EOFournisseur unSsTraitantSelectionne = null;
	private NSDictionary<String, Object> unArticleSelectionnable = null;

	public ArticleListeSelection(WOContext context) {
		super(context);
	}

	public void appendToResponse(WOResponse res, WOContext ctx) {
		super.appendToResponse(res, ctx);
	}

	public boolean synchronizesVariablesWithBindings() {
		return false;
	}

	public void reset() {
		modificationEnCours = false;
		avertissement = "";
		resetTypesAchat();
		typesAchatCommuns = null;
		resetAttributions();
		attributionsCommunes = null;
		ssTraitants = null;
		unSsTraitantSelectionne = null;
		unArticleSelectionnable = null;
		lesArticlesSelectionnes = null;
		unFiltreFournisseur = null;
		unFiltreReference = null;
		unFiltreLibelle = null;
	}

	private void resetTypesAchat() {
		unTypeAchatCommunSelectionne = null;
		isCmdeMarche = false;
		isTypeAchatHorsMarche = false;
		isTypeAchatMonopole = false;
		isTypeAchat3cmp = false;
		isTypeAchatSansAchat = false;
	}

	private void resetAttributions() {
		uneAttributionCommuneSelectionnee = null;
		filterTextAttribution = "";
	}

	public void initialiser() {
		EOCommande commande = laCommandeEnCours();
		EOTypeAchat typeAchat = commande.typeAchat();
		EOAttribution attribution = commande.attribution();
		if (attribution != null) {
			attributionsCommunes = new NSArray<EOAttribution>(attribution);
			setUneAttributionCommuneSelectionnee(attribution);
			setUnSsTraitantSelectionne(commande.fournisseur());
		}
		else if (typeAchat != null) {
			String libelle = typeAchat.typaLibelle();
			resetTypesAchat();
			if (EOTypeAchat.MARCHE_NON_FORMALISE.equals(libelle)) {
				isTypeAchatHorsMarche = true;
			}
			else if (EOTypeAchat.MONOPOLE.equals(libelle)) {
				isTypeAchatMonopole = true;
			}
			else if (EOTypeAchat.TROIS_CMP.equals(libelle)) {
				isTypeAchat3cmp = true;
			}
			else if (EOTypeAchat.SANS_ACHAT.equals(libelle)) {
				isTypeAchatSansAchat = true;
			}
		}
		lesArticlesSelectionnes = null;
		unFiltreLibelle = null;
		unFiltreFournisseur = null;
		unFiltreReference = null;
		modificationEnCours = false;

	}

	public WOComponent selectTypeAchat() {
		modificationEnCours = true;
		return null;
	}

	public WOComponent selectAttribution() {
		modificationEnCours = false;
		return null;
	}

	public WOComponent selectArticle() {
		EOCommande commande = laCommandeEnCours();
		EOEditingContext edc = laCommandeEnCours().editingContext();
		setAvertissement(null);
		if (commande.articles() == null || commande.articles().count() == 0) {
			NSArray<NSDictionary<String, Object>> articles = getLesArticlesSelectionnes();
			if (articles != null && articles.count() > 0) {
				// Verification que le fournisseur est unique
				NSDictionary<String, Object> unArticle = articles.lastObject();
				String fouCode = (String) unArticle.objectForKey("FOUCODE");
				EOQualifier qual = EOQualifier.qualifierWithQualifierFormat("FOUCODE != %@", new NSArray<Object>(fouCode));
				if (EOQualifier.filteredArrayWithQualifier(articles, qual).count() > 1) {
					setAvertissement("Tous les articles s&eacute;lectionn&eacute;s doivent appartenir au m&ecirc;me fournisseur.");
					resetTypesAchat();
					typesAchatCommuns = null;
					resetAttributions();
					attributionsCommunes = null;
					return null;
				}
				/*
				 * NSArray fournisseurs = FinderFournisseur.getFournisseurs(edc, articles);
				 * 
				 * if (fournisseurs!=null && fournisseurs.count()>0) { if (fournisseurs.count()>1) {
				 * setAvertissement("Tous les articles s&eacute;lectionn&eacute;s doivent appartenir au m&ecirc;me fournisseur."); resetTypesAchat();
				 * typesAchatCommuns = null; resetAttributions(); attributionsCommunes = null; return null; } }
				 */

				// Creation d'un tableau d'articles repondant a l'interface EOCatalogue
				NSMutableArray<EOCatalogue> lesArticles = new NSMutableArray<EOCatalogue>();
				Enumeration<NSDictionary<String, Object>> enumArticles = articles.objectEnumerator();
				while (enumArticles.hasMoreElements()) {
					NSDictionary<String, Object> article = enumArticles.nextElement();
					BigDecimal cle = (BigDecimal) article.objectForKey("CLE");
					EOCatalogue lArticle = FinderArticle.getArticle(edc, new Integer(cle.intValue()), commande.exercice());
					if (lArticle != null) {
						lesArticles.addObject(lArticle);
					}
				}

				attributionsCommunes = FinderAttribution.getAttributionsCommunes(edc, lesArticles);
				typesAchatCommuns = FinderTypeAchat.getTypeAchatsCommuns(edc, lesArticles);

				if (typesAchatCommuns != null && typesAchatCommuns.count() > 0) {
					isCmdeMarche = false;
					if (typesAchatCommuns.count() == 1) {
						setUnTypeAchatCommunSelectionne(typesAchatCommuns.lastObject());
					}
				}
				else {
					setUnTypeAchatCommunSelectionne(null);
				}
				if (attributionsCommunes != null && attributionsCommunes.count() > 0) {
					setUnTypeAchatCommunSelectionne(null);
					isCmdeMarche = true;
					if (attributionsCommunes.count() == 1) {
						setUneAttributionCommuneSelectionnee(attributionsCommunes.lastObject());
					}
					else {
						setUneAttributionCommuneSelectionnee(null);
					}
				}
				else {
					NSArray<EOAttribution> attributions = FinderAttribution.getAttributionsCommunes(edc, lesArticles);
					if (attributions != null && attributions.count() > 0) {
						setAvertissement("Attention, un ou plusieurs articles peuvent-&ecirc;tre command&eacute;s sur un march&eacute;");
					}
					resetAttributions();
				}

			}
			else {
				resetTypesAchat();
				resetAttributions();
				typesAchatCommuns = null;
				attributionsCommunes = null;
			}
			modificationEnCours = false;
		}

		return null;
	}

	public WOComponent affiner() {
		ArticleRechercheAvancee nextPage = (ArticleRechercheAvancee) pageWithName("ArticleRechercheAvancee");
		nextPage.initialiser();
		nextPage.setRechercheAvanceeDirecte(false);
		return nextPage;
	}

	public void annuler() {
		reset();
		dgArticles().queryBindings().removeAllObjects();
	}

	public WOComponent ajouter() {
		EOCommande laCommande = laCommandeEnCours();
		//NSArray articles = dgArticles().selectedObjects();
		NSArray<NSDictionary<String, Object>> articles = getLesArticlesSelectionnes();
		// Creation d'un tableau d'articles repondant a l'interface EOCatalogue
		NSMutableArray<EOCatalogue> lesArticles = new NSMutableArray<EOCatalogue>();
		Enumeration<NSDictionary<String, Object>> enumArticles = articles.objectEnumerator();
		while (enumArticles.hasMoreElements()) {
			NSDictionary<String, Object> article = enumArticles.nextElement();
			BigDecimal cle = (BigDecimal) article.objectForKey("CLE");
			EOCatalogue lArticle = FinderArticle.getArticle(laCommande.editingContext(), new Integer(cle.intValue()), laCommande.exercice());
			if (lArticle != null) {
				lesArticles.addObject(lArticle);
			}
		}
		EOFournisseur leFournisseur = laCommande.fournisseur();
		EOAttribution lAttribution = laCommande.attribution();
		EOTypeAchat leTypeAchat = laCommande.typeAchat();

		if (lAttribution == null) {
			lAttribution = getUneAttributionCommuneSelectionnee();
		}
		if (leTypeAchat == null) {
			leTypeAchat = getUnTypeAchatCommunSelectionne();
		}
		if (leFournisseur == null) {
			if (getUnSsTraitantSelectionne() != null) {
				leFournisseur = getUnSsTraitantSelectionne();
			}
			else {
				leFournisseur = ((EOCatalogue) lesArticles.lastObject()).fournisseur();
			}

		}
		try {
			session.getFactoryCommande().ajouterArticles(laCommande.editingContext(), laCommande, leFournisseur, lesArticles, lAttribution, leTypeAchat);
			if (ZStringUtil.isEmpty(laCommande.commLibelle())) {
				EOArticle firstArticle = laCommande.articles().objectAtIndex(0);
				laCommande.setCommLibelle(firstArticle.artLibelle());
			}
		} catch (FactoryException e) {
			session.setAlertMessage(e.getMessageFormatte());
		}

		return NavigationCtrl.goToSavedBonDeCommande(session, laCommande, null, "Articles");
	}

	public boolean isAjouterDisabled() {
		boolean isAjouterDisabled = true;
		// NSArray articles = dgArticles().selectedObjects();
		NSArray<NSDictionary<String, Object>> articles = getLesArticlesSelectionnes();
		if (articles != null && articles.count() > 0) {
			EOCommande laCommande = laCommandeEnCours();
			EOAttribution lAttribution = laCommande.attribution();
			EOTypeAchat leTypeAchat = laCommande.typeAchat();

			if (lAttribution == null) {
				lAttribution = getUneAttributionCommuneSelectionnee();
			}
			if (leTypeAchat == null) {
				leTypeAchat = getUnTypeAchatCommunSelectionne();
			}

			if (lAttribution != null || leTypeAchat != null) {
				isAjouterDisabled = false;
			}
		}
		return isAjouterDisabled;
	}

	public String getAvertissement() {
		return avertissement;
	}

	public void setAvertissement(String avertissement) {
		this.avertissement = avertissement;
	}

	public boolean isCmdeMarcheDisabled() {
		boolean isCmdeMarcheDisabled = true;
		EOCommande commande = laCommandeEnCours();
		if (commande.attribution() == null && getAttributionsCommunes() != null && getAttributionsCommunes().count() > 0) {
			isCmdeMarcheDisabled = false;
		}
		return isCmdeMarcheDisabled;
	}

	public boolean isCmdeMarche() {
		return isCmdeMarche;
	}

	public void setIsCmdeMarche(boolean isCmdeMarche) {
		if (modificationEnCours == false && isCmdeMarche) {
			resetTypesAchat();
			setAvertissement(null);
			this.isCmdeMarche = isCmdeMarche;
			if (attributionsCommunes != null && attributionsCommunes.count() == 1) {
				setUneAttributionCommuneSelectionnee(attributionsCommunes.lastObject());
			}
			modificationEnCours = true;
		}
	}

	public boolean isTypeAchatHorsMarcheDisabled() {
		boolean isTypeAchatHorsMarcheDisabled = true;
		NSArray<EOTypeAchat> typesAchat = getTypesAchatCommuns();
		if (typesAchat != null && typesAchat.count() > 0) {
			@SuppressWarnings("unchecked")
			NSArray<String> libelles = (NSArray<String>) typesAchat.valueForKeyPath("typaLibelle");
			if (libelles.containsObject(EOTypeAchat.MARCHE_NON_FORMALISE)) {
				isTypeAchatHorsMarcheDisabled = false;
			}
		}

		return isTypeAchatHorsMarcheDisabled;
	}

	public boolean isTypeAchatHorsMarche() {
		EOTypeAchat leTypeAchat = getUnTypeAchatCommunSelectionne();
		if (leTypeAchat != null && leTypeAchat.typaLibelle().equals(EOTypeAchat.MARCHE_NON_FORMALISE)) {
			isTypeAchatHorsMarche = true;
		}
		return isTypeAchatHorsMarche;
	}

	public void setIsTypeAchatHorsMarche(boolean isTypeAchatHorsMarche) {
		//		if (modificationEnCours == false && isTypeAchatHorsMarche) {
		if (attributionsCommunes != null && attributionsCommunes.count() > 0) {
			setAvertissement("Attention, un ou plusieurs articles peuvent-&ecirc;tre command&eacute;s sur un march&eacute;");
		}
		resetAttributions();
		resetTypesAchat();
		this.isTypeAchatHorsMarche = isTypeAchatHorsMarche;
		setUnTypeAchatCommunSelectionne(FinderTypeAchat.getTypeAchat(laCommandeEnCours().editingContext(), EOTypeAchat.MARCHE_NON_FORMALISE));
		modificationEnCours = true;
		//		}
	}

	public boolean isTypeAchatMonopoleDisabled() {
		boolean isTypeAchatMonopoleDisabled = true;
		NSArray<EOTypeAchat> typesAchat = getTypesAchatCommuns();
		if (typesAchat != null && typesAchat.count() > 0) {
			@SuppressWarnings("unchecked")
			NSArray<String> libelles = (NSArray<String>) typesAchat.valueForKeyPath("typaLibelle");
			if (libelles.containsObject(EOTypeAchat.MONOPOLE)) {
				isTypeAchatMonopoleDisabled = false;
			}
		}

		return isTypeAchatMonopoleDisabled;
	}

	public boolean isTypeAchatMonopole() {
		EOTypeAchat leTypeAchat = getUnTypeAchatCommunSelectionne();
		if (leTypeAchat != null && leTypeAchat.typaLibelle().equals(EOTypeAchat.MONOPOLE)) {
			isTypeAchatMonopole = true;
		}
		return isTypeAchatMonopole;
	}

	public void setIsTypeAchatMonopole(boolean isTypeAchatMonopole) {
		if (modificationEnCours == false && isTypeAchatMonopole) {
			isCmdeMarche = false;
			isTypeAchatHorsMarche = false;
			this.isTypeAchatMonopole = isTypeAchatMonopole;
			isTypeAchat3cmp = false;
			isTypeAchatSansAchat = false;
			setUneAttributionCommuneSelectionnee(null);
			modificationEnCours = false;
			setUnTypeAchatCommunSelectionne(FinderTypeAchat.getTypeAchat(laCommandeEnCours().editingContext(), EOTypeAchat.MONOPOLE));
			modificationEnCours = true;
		}
	}

	public boolean isTypeAchat3cmpDisabled() {
		boolean isTypeAchat3cmpDisabled = true;
		NSArray<EOTypeAchat> typesAchat = getTypesAchatCommuns();
		if (typesAchat != null && typesAchat.count() > 0) {
			@SuppressWarnings("unchecked")
			NSArray<String> libelles = (NSArray<String>) typesAchat.valueForKeyPath("typaLibelle");
			if (libelles.containsObject(EOTypeAchat.TROIS_CMP)) {
				isTypeAchat3cmpDisabled = false;
			}
		}
		return isTypeAchat3cmpDisabled;
	}

	public boolean isTypeAchat3cmp() {
		EOTypeAchat leTypeAchat = getUnTypeAchatCommunSelectionne();
		if (leTypeAchat != null && leTypeAchat.typaLibelle().equals(EOTypeAchat.TROIS_CMP)) {
			isTypeAchat3cmp = true;
		}
		return isTypeAchat3cmp;
	}

	public void setIsTypeAchat3cmp(boolean isTypeAchat3cmp) {
		if (modificationEnCours == false && isTypeAchat3cmp) {
			isCmdeMarche = false;
			isTypeAchatHorsMarche = false;
			isTypeAchatMonopole = false;
			this.isTypeAchat3cmp = isTypeAchat3cmp;
			isTypeAchatSansAchat = false;
			setUneAttributionCommuneSelectionnee(null);
			modificationEnCours = false;
			setUnTypeAchatCommunSelectionne(FinderTypeAchat.getTypeAchat(laCommandeEnCours().editingContext(), EOTypeAchat.TROIS_CMP));
			modificationEnCours = true;
		}
	}

	public boolean isTypeAchatSansAchatDisabled() {
		boolean isTypeAchatSansAchatDisabled = true;
		NSArray<EOTypeAchat> typesAchat = getTypesAchatCommuns();
		if (typesAchat != null && typesAchat.count() > 0) {
			@SuppressWarnings("unchecked")
			NSArray<String> libelles = (NSArray<String>) typesAchat.valueForKeyPath("typaLibelle");
			if (libelles.containsObject(EOTypeAchat.SANS_ACHAT)) {
				isTypeAchatSansAchatDisabled = false;
			}
		}
		return isTypeAchatSansAchatDisabled;
	}

	public boolean isTypeAchatSansAchat() {
		EOTypeAchat leTypeAchat = getUnTypeAchatCommunSelectionne();
		if (leTypeAchat != null && leTypeAchat.typaLibelle().equals(EOTypeAchat.SANS_ACHAT)) {
			isTypeAchatSansAchat = true;
		}
		return isTypeAchatSansAchat;
	}

	public void setIsTypeAchatSansAchat(boolean isTypeAchatSansAchat) {
		if (modificationEnCours == false && isTypeAchatSansAchat) {
			isCmdeMarche = false;
			isTypeAchatHorsMarche = false;
			isTypeAchatMonopole = false;
			isTypeAchat3cmp = false;
			this.isTypeAchatSansAchat = isTypeAchatSansAchat;
			setUneAttributionCommuneSelectionnee(null);
			modificationEnCours = false;
			setUnTypeAchatCommunSelectionne(FinderTypeAchat.getTypeAchat(laCommandeEnCours().editingContext(), EOTypeAchat.SANS_ACHAT));
			modificationEnCours = true;
		}
	}

	public String getFilterTextAttribution() {
		return filterTextAttribution;
	}

	public void setFilterTextAttribution(String filterTextAttribution) {
		this.filterTextAttribution = filterTextAttribution;
	}

	public boolean isAfficherSsTraitants() {
		boolean isAfficherSsTraitants = false;
		EOAttribution attribution = getUneAttributionCommuneSelectionnee();

		if (attribution != null) {
			ssTraitants = FinderFournisseur.getFournisseurs(laCommandeEnCours().editingContext(), attribution);
			if (ssTraitants != null && ssTraitants.count() > 1) {
				isAfficherSsTraitants = true;
			}
			else {
				ssTraitants = null;
			}
		}
		return isAfficherSsTraitants;
	}

	public boolean isArticleEligible() {
		boolean isArticleEligible = true;

		/*
		 * EOCatalogue article = getUnArticleSelectionnable(); if (article != null) { EOCommande laCommande = laCommandeEnCours(); NSArray
		 * articlesDejaPresents = null; NSArray articles = laCommande.articles(); if ( articles != null && articles.count()>0) { if
		 * (laCommande.isSurUnMarche()) { articlesDejaPresents = (NSArray)articles.valueForKeyPath(EOArticle.ATTRIBUTION_KEY); } else {
		 * articlesDejaPresents = (NSArray)articles.valueForKeyPath(EOArticle.ARTICLE_CATALOGUE_KEY); }
		 * 
		 * if (articlesDejaPresents.containsObject(article)) { isArticleEligible = false; } } }
		 */return isArticleEligible;
	}

	public String artDetail() {
		String artDetail = null;
		NSDictionary<String, Object> article = getUnArticleSelectionnable();
		if (article != null && article.objectForKey("CNLIBELLE") != null) {
			artDetail = (String) article.objectForKey("CNLIBELLE");
			if (article.objectForKey("ATTRIBUTION") != null && !article.objectForKey("ATTRIBUTION").equals(NSKeyValueCoding.NullValue)) {
				artDetail += "<br>";
				artDetail += (String) article.objectForKey("ATTRIBUTION");
			}
		}
		return artDetail;
	}

	public NSDictionary<String, Object> getUnArticleSelectionnable() {
		return unArticleSelectionnable;
	}

	public void setUnArticleSelectionnable(NSDictionary<String, Object> unArticleSelectionnable) {
		this.unArticleSelectionnable = unArticleSelectionnable;
	}

	public NSArray<EOAttribution> getAttributionsCommunes() {
		return attributionsCommunes;
	}

	public void setAttributionsCommunes(NSArray<EOAttribution> attributionsCommunes) {
		this.attributionsCommunes = attributionsCommunes;
	}

	public NSArray<EOTypeAchat> getTypesAchatCommuns() {
		return typesAchatCommuns;
	}

	public void setTypesAchatCommuns(NSArray<EOTypeAchat> typesAchatCommuns) {
		this.typesAchatCommuns = typesAchatCommuns;
	}

	public EOAttribution getUneAttributionCommune() {
		return uneAttributionCommune;
	}

	public void setUneAttributionCommune(EOAttribution uneAttributionCommune) {
		this.uneAttributionCommune = uneAttributionCommune;
	}

	public EOAttribution getUneAttributionCommuneSelectionnee() {
		return uneAttributionCommuneSelectionnee;
	}

	public void setUneAttributionCommuneSelectionnee(EOAttribution uneAttributionCommuneSelectionnee) {
		if (modificationEnCours == false) {
			this.uneAttributionCommuneSelectionnee = uneAttributionCommuneSelectionnee;
			modificationEnCours = true;
		}
		if (this.uneAttributionCommuneSelectionnee != null) {
			isCmdeMarche = true;
		}
	}

	public EOTypeAchat getUnTypeAchatCommun() {
		return unTypeAchatCommun;
	}

	public void setUnTypeAchatCommun(EOTypeAchat unTypeAchatCommun) {
		this.unTypeAchatCommun = unTypeAchatCommun;
	}

	public EOTypeAchat getUnTypeAchatCommunSelectionne() {
		return unTypeAchatCommunSelectionne;
	}

	public void setUnTypeAchatCommunSelectionne(EOTypeAchat unTypeAchatCommunSelectionne) {
		this.unTypeAchatCommunSelectionne = unTypeAchatCommunSelectionne;
		if (unTypeAchatCommunSelectionne == null) {
			resetTypesAchat();
		}
		else {
			isCmdeMarche = false;
		}
	}

	public boolean isSsTraitantsPopupDisabled() {
		boolean isSsTraitantsPopupDisabled = true;

		if (isCmdeMarcheDisabled() == false && getUneAttributionCommuneSelectionnee() != null) {
			isSsTraitantsPopupDisabled = false;
		}
		return isSsTraitantsPopupDisabled;
	}

	public EOFournisseur getUnSsTraitantSelectionne() {
		if (unSsTraitantSelectionne == null) {
			EOCommande commande = laCommandeEnCours();
			EOFournisseur fournisseur = commande.fournisseur();
			if (fournisseur != null) {
				unSsTraitantSelectionne = fournisseur;
			}
		}
		return unSsTraitantSelectionne;
	}

	public void setUnSsTraitantSelectionne(EOFournisseur unSsTraitantSelectionne) {
		if (modificationEnCours == false) {
			this.unSsTraitantSelectionne = unSsTraitantSelectionne;
			modificationEnCours = true;
		}
	}

	public NSArray<NSDictionary<String, Object>> getLesArticlesSelectionnes() {
		return lesArticlesSelectionnes;
	}

	public void setLesArticlesSelectionnes(NSArray<NSDictionary<String, Object>> lesArticlesSelectionnes) {
		if (modificationEnCours == false && lesArticlesSelectionnes != null) {
			this.lesArticlesSelectionnes = lesArticlesSelectionnes;
			dgArticles().setSelectedObjects(lesArticlesSelectionnes);
		}
		modificationEnCours = false;
	}

	public NSArray<String> updateContainerIDs() {
		return new NSArray<String>(new String[] {
				"ContainerTypeAchat", "ContainerBoutons"
		});
	}

	@SuppressWarnings("unchecked")
	public WOActionResults filtrerArticles() {
		EOKeyValueQualifier qualFournisseur = null, qualReference = null, qualLibelle = null;

		lesArticlesAAfficher = dgArticles().allObjects();

		if (unFiltreFournisseur() != null && unFiltreFournisseur().length() > 0) {
			qualFournisseur = new EOKeyValueQualifier("FOUNOM", EOQualifier.QualifierOperatorCaseInsensitiveLike, "*" + unFiltreFournisseur() + "*");
			lesArticlesAAfficher = EOQualifier.filteredArrayWithQualifier(lesArticlesAAfficher(), qualFournisseur);
		}
		if (unFiltreReference() != null && unFiltreReference().length() > 0) {
			qualReference = new EOKeyValueQualifier("REFERENCE", EOQualifier.QualifierOperatorCaseInsensitiveLike, "*" + unFiltreReference() + "*");
			lesArticlesAAfficher = EOQualifier.filteredArrayWithQualifier(lesArticlesAAfficher(), qualReference);
		}
		if (unFiltreLibelle() != null && unFiltreLibelle().length() > 0) {
			qualLibelle = new EOKeyValueQualifier("LIBELLE", EOQualifier.QualifierOperatorCaseInsensitiveLike, "*" + unFiltreLibelle() + "*");
			lesArticlesAAfficher = EOQualifier.filteredArrayWithQualifier(lesArticlesAAfficher(), qualLibelle);
		}

		return null;
	}

	private String unFiltreLibelle;

	/**
	 * @return the unFiltreLibelle
	 */
	public String unFiltreLibelle() {
		return unFiltreLibelle;
	}

	/**
	 * @param unFiltreLibelle the unFiltreLibelle to set
	 */
	public void setUnFiltreLibelle(String unFiltreLibelle) {
		this.unFiltreLibelle = unFiltreLibelle;
	}

	/**
	 * @return the lesArticlesAAfficher
	 */
	@SuppressWarnings("unchecked")
	public NSArray<NSDictionary<String, Object>> lesArticlesAAfficher() {
		if (lesArticlesAAfficher == null) {
			lesArticlesAAfficher = dgArticles().allObjects();
		}
		return lesArticlesAAfficher;
	}

	/**
	 * @param lesArticlesAAfficher the lesArticlesAAfficher to set
	 */
	public void setLesArticlesAAfficher(NSArray<NSDictionary<String, Object>> lesArticlesAAfficher) {
		this.lesArticlesAAfficher = lesArticlesAAfficher;
	}

	private String unFiltreReference;

	/**
	 * @return the unFiltreReference
	 */
	public String unFiltreReference() {
		return unFiltreReference;
	}

	/**
	 * @param unFiltreReference the unFiltreReference to set
	 */
	public void setUnFiltreReference(String unFiltreReference) {
		this.unFiltreReference = unFiltreReference;
	}

	private String unFiltreFournisseur;

	/**
	 * @return the unFiltreFournisseur
	 */
	public String unFiltreFournisseur() {
		return unFiltreFournisseur;
	}

	/**
	 * @param unFiltreFournisseur the unFiltreFournisseur to set
	 */
	public void setUnFiltreFournisseur(String unFiltreFournisseur) {
		this.unFiltreFournisseur = unFiltreFournisseur;
	}

	public boolean isOption() {
		boolean isOption = false;

		if (getUnArticleSelectionnable() != null &&
				!getUnArticleSelectionnable().objectForKey("ARTICLE_PERE").equals(NSKeyValueCoding.NullValue)) {
			isOption = true;
		}
		return isOption;
	}

}